function result = calculateOperation(a,exponent_length,mantissa_length)

    format long

    bias = 2^(exponent_length-1)-1;
    a_bin = dec2bin(hex2dec(a),exponent_length+mantissa_length+1);
    
    a_exponent = 0;
    a_mantissa = 0;
    
    denormalized = 0;
    
    infinity_counter = 0;
    
    % Calculate exponent value
    for i=2:exponent_length+1
        if(a_bin(i) == '1')
          infinity_counter = infinity_counter + 1;
          a_exponent = a_exponent+2^(exponent_length-i+1); 
        end
    end
        
    a_exponent = a_exponent - bias;
    result = 2^a_exponent;
    
     if(a_exponent ~= -127)
        % Number is normalized
        % Add the hidden mantissa bit
        a_mantissa = 2^0;
     else
        % Number is de-normalized
        disp('De-Normalized');
        a_mantissa = 0;
        denormalized = 1;
     end
     
     % Calculate mantissa value
     for i=exponent_length+2:exponent_length+1+mantissa_length
           if(a_bin(i) == '1')
               if(denormalized == 1)
                a_mantissa = a_mantissa + (2^(-i+exponent_length+2));
               else
                a_mantissa = a_mantissa + (2^(-1-i+exponent_length+2));
               end
           end
     end
     
     % Is number positive or negative
     if(a_bin(1) == '1')
        result = -1*result*a_mantissa; 
     else
        result = result*a_mantissa;  
     end
     
     if(infinity_counter == exponent_length)
        if(a_mantissa == 1)
           result = 'Infinity';
        else
            result = 'NaN';
        end
     end
     return

end