clc;
clear all;

% The number of samples
num_samples = 100;

operation = 0; %0 = add, 1 = subtraction

exponentNum = 11;
mantissaNum = 52; % normalized mantissa containes a x*2^-1....
range = 2^(mantissaNum+exponentNum+1);
% The input to the IP demands a normalized floating-point number
% This is done by "or-ing" the sample with the "mantissaValue"
mantissaValue = 2^mantissaNum;

% Initializing
a_exponent = dec2bin(0,exponentNum);
a_mantissa = dec2bin(mantissaValue,mantissaNum);
a_sign = 0;

b_exponent = dec2bin(0,exponentNum);
b_mantissa = dec2bin(mantissaValue,mantissaNum);
b_sign = 0;

exponent_large = dec2bin(0,exponentNum);
exponent_small = dec2bin(0,exponentNum);
mantissa_large = dec2bin(0,mantissaNum);
mantissa_small = dec2bin(0,mantissaNum);

%a = hex2dec('00FFFFFFFFFFFFF');
%b = hex2dec('0000000000000000');

% This is the file containing testbench data
file_testbench = fopen('C:\Users\Audun\Documents\master-thesis\fpu_core\fpu_testbench.dat', 'w');
%file_testbench = fopen('fpu_testbench.dat', 'w');
% This file contains the decimal representation of the testbench
file_decimal = fopen('fpu_testbench_decimal.dat', 'w');

counter = 1;

for i=1:num_samples,
        if exponentNum+mantissaNum+1 > 52
           a_1 = randi([0 1],1,exponentNum+mantissaNum+1);
           a_1 = num2str(a_1(1,:));
           a = regexprep(a_1,'[^\w'']','');
           
           b_1 = randi([0 1],1,exponentNum+mantissaNum+1);
           b_1 = num2str(b_1(1,:));
           b = regexprep(b_1,'[^\w'']',''); % Remove all spaces
           
           fprintf(file_testbench, '%s %s\n', a, b);
        else
            a = randi(range,1);
            b = randi(range,1);
            a_bin = dec2bin(a, exponentNum + mantissaNum + 1);
            b_bin = dec2bin(b, exponentNum + mantissaNum + 1);
            fprintf(file_testbench, '%s %s\n', a_bin, b_bin);
        end

        
        %fprintf(file_decimal, '%d %d %d\n', a_value, b_value, a_value+b_value);
        %fprintf(fid, '%X %i\n', r, Add);
end
fclose(file_testbench);
fclose(file_decimal);