function result = generateTestbench(path, exponent_length, mantissa_length, samples_num)
    file_testbench = fopen(path, 'w');
    
    for i=1:samples_num,
        % Need this cause Matlab does not handle so big numbers
        if exponent_length+mantissa_length+1 > 52
           a_1 = randi([0 1],1,exponent_length+mantissa_length+1);
           a_1 = num2str(a_1(1,:));
           a = regexprep(a_1,'[^\w'']','');
           
           b_1 = randi([0 1],1,exponent_length+mantissa_length+1);
           b_1 = num2str(b_1(1,:));
           b = regexprep(b_1,'[^\w'']',''); % Remove all spaces
           
           fprintf(file_testbench, '%s %s\n', a, b);
        else
            range = 2^(mantissa_length+exponent_length+1);
            a = randi(range,1);
            b = randi(range,1);
            a_bin = dec2bin(a, exponent_length + mantissa_length + 1);
            b_bin = dec2bin(b, exponent_length + mantissa_length + 1);
            fprintf(file_testbench, '%s %s\n', a_bin, b_bin);
        end
    end
    
    result = 'Generation Complete!';
    
    fclose(file_testbench);
end