`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   16:28:32 04/28/2014
// Design Name:   system
// Module Name:   C:/Users/Audun/Documents/master-thesis/fpu_core/compare_adders_tb.v
// Project Name:  fpu_core
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: system
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module compare_adders_tb;

	// Inputs
	reg [63:0] a;
	reg [63:0] b;
	reg [2:0] operation;
	reg operation_nd;
	reg clk;
	reg reset;

	// Outputs
	//wire operation_rfd;
	wire [63:0] result_ip;
	wire [63:0] result_conf;
	wire rdy;
	
	integer   data_file; //file handler
	integer   data_file_result; //file handler
	integer	 scan_file; //file handler	
	reg		[2:0] state;
	
	integer counter;
	
	`define NULL 0
	
	parameter zero=0, one=1, two=2, three=3, four=4, five=5, six=6, seven=7;

	// Instantiate the Unit Under Test (UUT)
	system uut (
		.a(a), 
		.b(b), 
		.operation(operation), 
		.operation_nd(operation_nd), 
		//.operation_rfd(operation_rfd), 
		.clk(clk), 
		.reset(reset), 
		.result_ip(result_ip), 
		//.result_conf(result_conf),
		.rdy(rdy)
	);

	initial begin
		// Initialize Inputs
		a = 0;
		b = 0;
		operation = 0;
		operation_nd = 0;
		clk = 0;
		reset = 1;
		counter = 0;

		data_file = $fopen("fpu_testbench.dat", "r");
		data_file_result = $fopen("../MATLAB/fpu_testbench_results.txt", "w");
		if (data_file == `NULL) begin
			$display("data_file handle is NULL");
			$finish;
		end
		
		if (data_file_result == `NULL) begin
			$display("data_file handle is NULL");
			$finish;
		end
		// Wait 100 ns for global reset to finish
		#200;
		
		reset = 0;
		
		repeat (5000) @ (posedge clk);
		$fclose(data_file);
		$fclose(data_file_result);
		reset = 1;
		#100 
		$finish;

	end
	
	always @(state) begin
	 case (state)
			zero:	
				operation_nd = 0;
			one:
				scan_file = $fscanf(data_file, "%b %b\n", a, b);
				//operation_nd = 0;
			two:
				//operation = 0;
				if(operation == 3) 
					operation = 0;
					//operation_nd = 1;
				else
					operation = operation + 1;
					//operation_nd = 1;
				
			three:
				operation_nd = 1;
			four:
				//operation_nd = 0;
				//$display(result);
				operation_nd = 1;
			five:
				operation_nd = 0;
			six:
				operation_nd = 0;
				//$fwrite(data_file_result, "%h %h\n", result_ip, result_ip);
			seven:
				$fwrite(data_file_result, "%h %h %d\n", result_ip, result_conf, operation);
	 endcase
	end
	
	always @(posedge clk or posedge reset) begin
		if (reset == 1)	
			state = one;
		else
			case (state)
					zero:
						if(rdy == 0)
							state = one;
						else
							state = zero;
					one:
						state = two;
					two:
						state = three;
					three:
						state = four;
					four:
						if(rdy == 1)
							state = five;
						else
							state = four;
					five:
						state = six;
					six:
						state = seven;
					seven:
						state = zero;
			endcase
			
	end
	
	
	always #5	clk =! clk;
      
endmodule

