`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   16:37:22 05/18/2014
// Design Name:   configurable_adder_unsigned
// Module Name:   C:/Users/Audun/Documents/master-thesis/fpu_core/configurable_adder_unsigned_tb.v
// Project Name:  fpu_core
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: configurable_adder_unsigned
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module configurable_adder_unsigned_tb;

	// Inputs
	reg [14:0] a;
	reg [14:0] b;
	reg clk;
	reg clk_a;
	reg reset;
	reg new_data;
	reg [2:0] operation;

	// Outputs
	wire [14:0] result;
	wire rdy;
	
	integer   data_file; //file handler
	integer   data_file_result; //file handler
	integer	 scan_file; //file handler	
	reg		[2:0] state;
	
	integer counter;
	
	`define NULL 0
	
	parameter zero=0, one=1, two=2, three=3;

	// Instantiate the Unit Under Test (UUT)
	configurable_adder_unsigned uut (
		.a(a), 
		.b(b), 
		.clk(clk), 
		.clk_a(clk_a), 
		.reset(reset), 
		.new_data(new_data), 
		.operation(operation), 
		.result(result), 
		.rdy(rdy)
	);

	initial begin
		// Initialize Inputs
		a = 0;
		b = 0;
		clk = 0;
		clk_a = 0;
		reset = 1;
		new_data = 0;
		operation = 0;
		counter = 0;
		
		data_file = $fopen("fpu_testbench.dat", "r");
		data_file_result = $fopen("../MATLAB/fpu_testbench_results_conf.txt", "w");
		if (data_file == `NULL) begin
			$display("data_file handle is NULL");
			$finish;
		end
		
		if (data_file_result == `NULL) begin
			$display("data_file handle is NULL");
			$finish;
		end
		#200;
		
		reset = 0;
		
		repeat (5000) @ (posedge clk);
		$fclose(data_file);
		$fclose(data_file_result);
		reset = 1;
		#100 
		$finish;

	end
	
		always @(posedge rdy) begin
			#5
			$fwrite(data_file_result, "%h %d\n", result, operation);
			if(counter == 100)
				reset = 1;
			else
				counter = counter + 1;
		end
		
		always @(state) begin
		case (state)
			zero:
				new_data = 0;
			one:
				scan_file = $fscanf(data_file, "%b %b\n", a, b);
			two:
				if(operation == 1)
					operation = 0;
				else
					operation = operation + 1;
			three:
				new_data = 1;
		endcase
	end
	
	always @(posedge clk or posedge reset) begin
		if (reset == 1)	
			state = one;
		else
			case (state)
				zero:
					if(rdy == 0)
						state = zero;
					else
						state = one;
				one:
					state = two;
				two:
					state = three;
				three:
					state = zero;
			endcase;
	end
	
		always #5	clk =! clk;
		always #2	clk_a =! clk_a;
      
endmodule

