----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:11:55 05/16/2014 
-- Design Name: 
-- Module Name:    control_ready_signal - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity control_ready_signal is
	generic(
			OPERAND_LENGTH : integer := 32
			);
    Port ( clk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           ready_adder_sub : in  STD_LOGIC;
           ready_mult : in  STD_LOGIC;
           ready_div : in  STD_LOGIC;
			  result_adder_sub : in std_logic_vector(OPERAND_LENGTH-1 downto 0);
			  result_mult : in std_logic_vector(OPERAND_LENGTH-1 downto 0);
			  result_div : in std_logic_vector(OPERAND_LENGTH-1 downto 0);
           result : out  STD_LOGIC_VECTOR (OPERAND_LENGTH-1 downto 0);
           rdy : out  STD_LOGIC);
end control_ready_signal;

architecture Behavioral of control_ready_signal is

begin

	process(clk, reset, ready_adder_sub, ready_adder_sub, ready_mult, ready_div)
		begin
			if(reset = '1') then
				--sclr_adder_sub <= '0';
--				sclr_mult	 	<= '1';
--				sclr_div	 		<= '1';
			else
				if(rising_edge(clk)) then
					if(ready_adder_sub = '1') then
						result <= result_adder_sub;
					elsif(ready_mult = '1') then
						result <= result_mult;
					elsif(ready_adder_sub = '1') then 
						result <= result_adder_sub;
					elsif(ready_mult = '1') then
						result <= result_mult;
					elsif(ready_div = '1') then
						result <= result_div;
					else
					end if;
					
				end if;
			end if;
		end process;


end Behavioral;

