----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    15:24:06 05/16/2014 
-- Design Name: 
-- Module Name:    control_units - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity control_units is
    Port ( clk : in  STD_LOGIC;
           reset : in  STD_LOGIC;
           fpu_operation : in  STD_LOGIC_VECTOR (5 downto 0);
           operation_nd : in  STD_LOGIC;
			  ready			: in std_logic;
			  
			  adder_new_data : out std_logic;
			  mult_new_data : out std_logic;
			  div_new_data : out std_logic;
			  
			  sclr_adder_sub : out std_logic;
			  sclr_mult : out std_logic;
			  sclr_div : out std_logic;
			  
			  ce_adder_sub : out std_logic;
			  ce_mult : out std_logic;
			  ce_div : out std_logic
			  );
end control_units;

architecture Behavioral of control_units is

begin
		process(clk, reset, fpu_operation, operation_nd, ready)
		begin
			if(reset = '1') then
				sclr_adder_sub <= '1';
				sclr_mult <= '1';
				sclr_div <= '1';
				
				ce_adder_sub <= '0';
				ce_mult <= '0';
				ce_div <= '0';
			else
				if(rising_edge(clk)) then
					if(operation_nd = '1') then
						-- Addition and subtraction
						if(fpu_operation = "000" or fpu_operation ="001") then
							adder_new_data <= '1';
							mult_new_data <= '0';
							div_new_data <= '0';
							
							sclr_adder_sub <= '0';
							sclr_mult <= '1';
							sclr_div <= '1';
							
							ce_adder_sub <= '1';
							ce_mult <= '0';
							ce_div <= '0';
						-- Multiplication
						elsif(fpu_operation = "010") then
							mult_new_data <= '1';
							adder_new_data <= '0';
							div_new_data <= '0';
							
							sclr_adder_sub <= '1';
							sclr_mult <= '0';
							sclr_div <= '1';
							
							ce_adder_sub <= '0';
							ce_mult <= '1';
							ce_div <= '0';
						-- Division
						elsif(fpu_operation = "011") then
							div_new_data <= '1';
							adder_new_data <= '0';
							mult_new_data <= '0';
							
							sclr_adder_sub <= '1';
							sclr_mult <= '1';
							sclr_div <= '0';
							
							ce_adder_sub <= '0';
							ce_mult <= '0';
							ce_div <= '1';
						else
							div_new_data <= '0';
							adder_new_data <= '0';
							mult_new_data <= '0';
							
							sclr_adder_sub <= '1';
							sclr_mult <= '1';
							sclr_div <= '1';
							
							ce_adder_sub <= '0';
							ce_mult <= '0';
							ce_div <= '0';
						end if;
					elsif(ready = '1') then
						sclr_adder_sub <= '1';
						sclr_mult <= '1';
						sclr_div <= '1';
						ce_adder_sub <= '0';
						ce_mult <= '0';
						ce_div <= '0';
					else
					end if;
				end if;
			end if;
		end process;


end Behavioral;

