`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   17:08:33 05/26/2014
// Design Name:   fpu_double
// Module Name:   C:/Users/Audun/Documents/master-thesis/fpu_core/fpu_double_tb.v
// Project Name:  fpu_core
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: fpu_double
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module fpu_double_tb;

	// Inputs
	reg clk;
	reg rst;
	reg enable;
	reg [1:0] rmode;
	reg [2:0] fpu_op;
	reg [63:0] opa;
	reg [63:0] opb;

	// Outputs
	wire [63:0] out_fp;
	wire ready;
	wire underflow;
	wire overflow;
	wire inexact;
	wire exception;
	wire invalid;
	
	integer   data_file; //file handler
	integer   data_file_result; //file handler
	integer	 scan_file; //file handler	
	reg		[2:0] state;
	
	`define NULL 0
	
	parameter zero=0, one=1, two=2, three=3, four=4, five=5, six=6, seven=7;

	// Instantiate the Unit Under Test (UUT)
	fpu_double uut (
		.clk(clk), 
		.rst(rst), 
		.enable(enable), 
		.rmode(rmode), 
		.fpu_op(fpu_op), 
		.opa(opa), 
		.opb(opb), 
		.out_fp(out_fp), 
		.ready(ready), 
		.underflow(underflow), 
		.overflow(overflow), 
		.inexact(inexact), 
		.exception(exception), 
		.invalid(invalid)
	);

	initial begin
		// Initialize Inputs
		clk = 0;
		rst = 1;
		enable = 0;
		rmode = 0;
		fpu_op = 0;
		opa = 0;
		opb = 0;

		data_file = $fopen("fpu_double.dat", "r");
		data_file_result = $fopen("../MATLAB/fpu_testbench_results.txt", "w");
		if (data_file == `NULL) begin
			$display("data_file handle is NULL");
			$finish;
		end
		
		if (data_file_result == `NULL) begin
			$display("data_file handle is NULL");
			$finish;
		end
		// Wait 100 ns for global rst to finish
		#200;
		
		rst = 0;
		
		repeat (15000) @ (posedge clk);
		$fclose(data_file);
		$fclose(data_file_result);
		rst = 1;
		#100 
		$finish;

	end
	
	always @(state) begin
	 case (state)
			zero:	
				enable = 0;
			one:
				scan_file = $fscanf(data_file, "%b %b\n", opa, opb); 
				//enable = 0;
			two:
				//fpu_op = 0;
				if(fpu_op == 3) 
					fpu_op = 0;
					//enable = 1;
				else
					fpu_op = fpu_op + 1;
					//enable = 1;
				
			three:
				enable = 1;
			four:
				//enable = 0;
				//$display(result);
				enable = 1;
			five:
				enable = 1;
			six:
				enable = 0;
				//$fwrite(data_file_result, "%h %h\n", result_ip, result_ip);
			seven:
				$fwrite(data_file_result, "%h %h %d\n", out_fp, out_fp, fpu_op);
	 endcase
	end
	
	always @(posedge clk or posedge rst) begin
		if (rst == 1)	
			state = one;
		else
			case (state)
					zero:
						if(ready == 1)
							state = one;
						else
							state = zero;
					one:
						state = two;
					two:
						state = three;
					three:
						state = four;
					four:
						if(ready == 1)
							state = five;
						else
							state = four;
					five:
						state = six;
					six:
						state = seven;
					seven:
						state = zero;
			endcase
			
	end
	
	
	always #5	clk =! clk;
      
endmodule

