`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   17:11:33 05/30/2014
// Design Name:   system
// Module Name:   C:/Users/Audun/Documents/master-thesis/fpu_core/fpu_ip_tb.v
// Project Name:  fpu_core
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: system
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module fpu_ip_tb;

	// Inputs
	reg [63:0] a;
	reg [63:0] b;
	reg [2:0] operation;
	reg operation_nd;
	reg clk;
	reg reset;

	// Outputs
	wire [63:0] result_ip;
	wire rdy;
	wire underflow;
	wire overflow;
	wire invalid_op;
	wire divide_by_zero;
	
	integer   data_file; //file handler
	integer   data_file_result; //file handler
	integer	 scan_file; //file handler	
	reg		[2:0] state;
	
	`define NULL 0
	
	parameter zero=0, one=1, two=2, three=3, four=4, five=5;
	
	integer	counter;

	// Instantiate the Unit Under Test (UUT)
	system uut (
		.a(a), 
		.b(b), 
		.operation(operation), 
		.operation_nd(operation_nd), 
		.clk(clk), 
		.reset(reset), 
		.result_ip(result_ip), 
		.rdy(rdy), 
		.underflow(underflow), 
		.overflow(overflow), 
		.invalid_op(invalid_op), 
		.divide_by_zero(divide_by_zero)
	);

	initial begin
		// Initialize Inputs
		a = 0;
		b = 0;
		operation = 0;
		operation_nd = 0;
		clk = 0;
		reset = 1;
		counter = 0;

		data_file = $fopen("fpu_testbench.dat", "r");
		data_file_result = $fopen("../MATLAB/fpu_testbench_results.txt", "w");
		if (data_file == `NULL) begin
			$display("data_file handle is NULL");
			$finish;
		end
		
		if (data_file_result == `NULL) begin
			$display("data_file handle is NULL");
			$finish;
		end
		#200;
		
		reset = 0;
		
		repeat (5000) @ (posedge clk);
		$fclose(data_file);
		$fclose(data_file_result);
		reset = 1;
		#100 
		$finish;

	end
	
	always @(state == five) begin
		 a = 0;
		 b = 0;
		 //reset = 1;
		 operation_nd = 1;
	end
	
	always @(state) begin
		case (state)
			zero:
				operation_nd = 0;
			one:
				scan_file = $fscanf(data_file, "%b %b\n", a, b);
			two:
				if(operation == 3)
					operation = 0;
				else
					operation = operation + 1;
			three:
				operation_nd = 1;
			four:
				if(counter != 100)
					counter = counter + 1;
			//five:
				//operation_nd = 0;
		endcase
	end
	
	always @(posedge clk or posedge reset) begin
		if (reset == 1)	
			state = zero;
		else
			case (state)
				zero:
					if(reset == 1)
						state = zero;
					else
						state = one;
				one:
					state = two;
				two:
					state = three;
				three:
					state = four;
				four:
					if(counter == 100)
						state = five;
					else
						state = zero;
				five:
					state = five;
			endcase;
	end
	
	always #5 clk = !clk;
      
endmodule

