`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   13:15:09 05/26/2014
// Design Name:   fpu
// Module Name:   C:/Users/Audun/Documents/master-thesis/fpu_core/fpu_tb.v
// Project Name:  fpu_core
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: fpu
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module fpu_tb;

	// Inputs
	reg clk_i;
	reg [31:0] opa_i;
	reg [31:0] opb_i;
	reg [2:0] fpu_op_i;
	reg [1:0] rmode_i;
	reg start_i;

	// Outputs
	wire [31:0] output_o;
	wire ready_o;
	wire ine_o;
	wire overflow_o;
	wire underflow_o;
	wire div_zero_o;
	wire inf_o;
	wire zero_o;
	wire qnan_o;
	wire snan_o;
	
	integer   data_file; //file handler
	integer   data_file_result; //file handler
	integer	 scan_file; //file handler	
	reg		[2:0] state;
	
	`define NULL 0
	
	parameter zero=0, one=1, two=2, three=3, four=4, five=5, six=6, seven=7;

	// Instantiate the Unit Under Test (UUT)
	fpu uut (
		.clk_i(clk_i), 
		.opa_i(opa_i), 
		.opb_i(opb_i), 
		.fpu_op_i(fpu_op_i), 
		.rmode_i(rmode_i), 
		.output_o(output_o), 
		.start_i(start_i), 
		.ready_o(ready_o), 
		.ine_o(ine_o), 
		.overflow_o(overflow_o), 
		.underflow_o(underflow_o), 
		.div_zero_o(div_zero_o), 
		.inf_o(inf_o), 
		.zero_o(zero_o), 
		.qnan_o(qnan_o), 
		.snan_o(snan_o)
	);

	initial begin
		// Initialize Inputs
		clk_i = 0;
		opa_i = 0;
		opb_i = 0;
		fpu_op_i = 0;
		rmode_i = 0;
		start_i = 0;

		data_file = $fopen("fpu_testbench.dat", "r");
		data_file_result = $fopen("../MATLAB/fpu_testbench_results.txt", "w");
		if (data_file == `NULL) begin
			$display("data_file handle is NULL");
			$finish;
		end
		
		if (data_file_result == `NULL) begin
			$display("data_file handle is NULL");
			$finish;
		end
		
		state = zero;
		// Wait 100 ns for global reset to finish
		
//		start_i = 1;
//		opa_i = 'h40800000;
//		opb_i = 'h41266666;
//		#50
//		start_i = 0;
//		
//		#100
//		opa_i = 'h20823540;
//		opb_i = 'hE9D30008;
//		start_i = 1;
//		
//		#50
//		start_i = 0;
//		
//		#100
//		opa_i = 'hA1E24BAA;
//		opb_i = 'h18F86872;
		
        
		repeat (15000) @ (posedge clk_i);
		$fclose(data_file);
		$fclose(data_file_result);
		start_i = 0;
		#100 
		$finish;

	end
	
	always @(state) begin
	 case (state)
			zero:
				start_i = 0;
			one:
				scan_file = $fscanf(data_file, "%b %b\n", opa_i, opb_i); 
				//operation_nd = 0;
				//$fwrite(data_file_result, "%h %h\n", result_ip, result_ip);
			two:
				start_i = 1;
			three:
				if(fpu_op_i == 3)
					fpu_op_i = 0;
				else
					fpu_op_i = fpu_op_i + 1;
			four:
				start_i = 0;
	 endcase
	end
	
	always @(posedge clk_i or posedge start_i) begin

		case (state)
				zero:
					if(zero_o == 1 || ready_o == 1)
						state = one;
					else
						state = zero;
				one:
					state = two;
				two:
					state = three;
				three:
					state = four;
				four:
					state = zero;
		endcase
			
	end
	
	always #5 clk_i = !clk_i;
      
endmodule

