`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   17:25:21 06/03/2014
// Design Name:   system_conf
// Module Name:   C:/Users/Audun/Documents/master-thesis/fpu_core/system_conf_tb.v
// Project Name:  fpu_core
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: system_conf
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module system_conf_tb;

	// Inputs
	reg [19:0] a;
	reg [19:0] b;
	reg [2:0] operation;
	reg operation_nd;
	reg clk;
	reg reset;

	// Outputs
	wire [19:0] result_conf;
	wire rdy;
	wire underflow;
	wire overflow;
	wire invalid_op;
	wire divide_by_zero;
	
	integer   data_file; //file handler
	integer   data_file_result; //file handler
	integer 	 data_file_solution;
	integer	 scan_file; //file handler	
	integer 	 scan_file_solution;
	reg		[2:0] state;
	
	reg [19:0] solution; 
	integer dummy;
	
	integer counter;
	
	`define NULL 0
	
	parameter zero=0, one=1, two=2, three=3;

	// Instantiate the Unit Under Test (UUT)
	system_conf uut (
		.a(a), 
		.b(b), 
		.operation(operation), 
		.operation_nd(operation_nd), 
		.clk(clk), 
		.reset(reset), 
		.result_conf(result_conf), 
		.rdy(rdy), 
		.underflow(underflow), 
		.overflow(overflow), 
		.invalid_op(invalid_op), 
		.divide_by_zero(divide_by_zero)
	);

	initial begin
		// Initialize Inputs
		a = 0;
		b = 0;
		operation = 0;
		operation_nd = 0;
		clk = 0;
		reset = 1;
		counter = 0;

		data_file = $fopen("fpu_custom.dat", "r");
		data_file_result = $fopen("../MATLAB/fpu_testbench_results_conf.txt", "w");
		data_file_solution = $fopen("../MATLAB/fpu_testbench_results_ieee_float.txt", "r");
		if (data_file == `NULL) begin
			$display("data_file handle is NULL");
			$finish;
		end
		
		if (data_file_result == `NULL) begin
			$display("data_file handle is NULL");
			$finish;
		end
		#200;
		
		reset = 0;
		
		repeat (5000) @ (posedge clk);
		$fclose(data_file);
		$fclose(data_file_result);
		reset = 1;
		#100 
		$finish;

	end
	
	always @(posedge rdy) begin
		#25
		$fwrite(data_file_result, "%h %d\n", result_conf, operation);
		scan_file = $fscanf(data_file_solution, "%h %d\n", solution, dummy);
	end
	
	always @(posedge state == three) begin
		if(counter == 100)
			reset = 1;
		else
			counter = counter + 1;
	end
	
	always @(state) begin
		case (state)
			zero:
				operation_nd = 0;
			one:
				scan_file = $fscanf(data_file, "%b %b\n", a, b);
			two:
				if(operation == 2)
					operation = 0;
				else
					operation = operation + 1;
			three:
				operation_nd = 1;
		endcase
	end
	
	always @(posedge clk or posedge reset) begin
		if (reset == 1)	
			state = zero;
		else
			case (state)
				zero:
					if(reset == 1)
						state = zero;
					else
						state = one;
				one:
					state = two;
				two:
					state = three;
				three:
					if(rdy == 1)
						state = zero;
					else
						state = three;
			endcase;
	end
	
	always #5 clk = !clk;
      
endmodule

