`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   09:49:31 05/28/2014
// Design Name:   system_ieee_fixed
// Module Name:   C:/Users/Audun/Documents/master-thesis/fpu_core/system_ieee_fixed_tb.v
// Project Name:  fpu_core
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: system_ieee_fixed
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module system_ieee_fixed_tb;

	// Inputs
	reg clk;
	reg reset;
	reg [31:0] a;
	reg [31:0] b;
	reg [5:0] operation;
	reg operation_nd;

	// Outputs
	wire [32:0] sum_add_sub_o;
	wire [63:0] sum_mult_o;
	
	integer   data_file; //file handler
	integer	 scan_file; //file handler	
	reg		[2:0] state;
	
	`define NULL 0
	
	parameter zero=0, one=1, two=2, three=3;

	// Instantiate the Unit Under Test (UUT)
	system_ieee_fixed uut (
		.clk(clk), 
		.reset(reset), 
		.a(a), 
		.b(b), 
		.operation(operation), 
		.operation_nd(operation_nd), 
		.sum_add_sub_o(sum_add_sub_o),
		.sum_mult_o(sum_mult_o)
	);

	initial begin
		// Initialize Inputs
		clk = 0;
		reset = 1;
		a = 0;
		b = 0;
		operation = 0;
		operation_nd = 0;
		
		data_file = $fopen("fixed_testbench.dat", "r");
		if (data_file == `NULL) begin
			$display("data_file handle is NULL");
			$finish;
		end

		// Wait 100 ns for global reset to finish
		#200;
		reset = 0;
		
		repeat (15000) @ (posedge clk);
		$fclose(data_file);
		reset = 1;
		#100 
		$finish;
        
		// Add stimulus here

	end
	
	always @(state) begin
		case (state)
			zero:
				operation_nd = 0;
			one:
				scan_file = $fscanf(data_file, "%X %X\n", a, b);
			two:
				if(operation == 2)
					operation = 0;
				else
					operation = operation + 1;
			three:
				operation_nd = 1;
		endcase
	end
	
	always @(posedge clk or posedge reset) begin
		if (reset == 1)	
			state = zero;
		else
			case (state)
				zero:
					if(reset == 1)
						state = zero;
					else
						state = one;
				one:
					state = two;
				two:
					state = three;
				three:
					state = zero;
			endcase;
	end
	
	always #5 clk = !clk;
      
endmodule

