`timescale 1ns / 1ps

////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   13:50:58 05/27/2014
// Design Name:   system_ieee_float
// Module Name:   C:/Users/Audun/Documents/master-thesis/fpu_core/system_ieee_float_tb.v
// Project Name:  fpu_core
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: system_ieee_float
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module system_ieee_float_tb;

	// Inputs
	reg clk;
	reg reset;
	reg operation_nd;
	reg [5:0]operation;
	reg [19:0] a;
	reg [19:0] b;

	// Outputs
	wire [19:0] sum;
	wire	ready;
	
	integer   data_file; //file handler
	integer   data_file_result; //file handler
	integer	 scan_file; //file handler	
	reg		[2:0] state;
	
	integer counter;
	
	`define NULL 0
	
	parameter zero=0, one=1, two=2, three=3;

	// Instantiate the Unit Under Test (UUT)
	system_ieee_float uut (
		.clk(clk), 
		.reset(reset),
		.operation_nd(operation_nd),
		.operation(operation),
		.a(a), 
		.b(b), 
		.sum(sum),
		.ready(ready)
	);

	initial begin
		// Initialize Inputs
		clk = 0;
		reset = 1;
		a = 0;
		b = 0;
		operation = 0;
		operation_nd = 0;
		counter = 0;

		data_file = $fopen("fpu_custom.dat", "r");
		data_file_result = $fopen("../MATLAB/fpu_testbench_results_ieee_float.txt", "w");
		if (data_file == `NULL) begin
			$display("data_file handle is NULL");
			$finish;
		end
		
		if (data_file_result == `NULL) begin
			$display("data_file handle is NULL");
			$finish;
		end
		#200;
		
		reset = 0;
		
		repeat (5000) @ (posedge clk);
		$fclose(data_file);
		$fclose(data_file_result);
		reset = 1;
		#100 
		$finish;

	end
	
	always @(posedge ready) begin
		$fwrite(data_file_result, "%h %d\n", sum, operation);
	end
	
	always @(posedge state == three) begin
		if(counter == 100)
			reset = 1;
		else
			counter = counter + 1;
	end
	
	always @(state) begin
		case (state)
			zero:
				operation_nd = 0;
			one:
				scan_file = $fscanf(data_file, "%b %b\n", a, b);
			two:
				if(operation == 2)
					operation = 0;
				else
					operation = operation + 1;
			three:
				operation_nd = 1;
		endcase
	end
	
	always @(posedge clk or posedge reset) begin
		if (reset == 1)	
			state = zero;
		else
			case (state)
				zero:
					if(reset == 1)
						state = zero;
					else
						state = one;
				one:
					state = two;
				two:
					state = three;
				three:
					state = zero;
			endcase;
	end
	
	always #5 clk = !clk;
      
endmodule

