`timescale 1ns / 1ps
////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer:
//
// Create Date:   10:39:18 03/10/2014
// Design Name:   system
// Module Name:   D:/MasterThesis/fpu_core/testbench_system.v
// Project Name:  fpu_core
// Target Device:  
// Tool versions:  
// Description: 
//
// Verilog Test Fixture created by ISE for module: system
//
// Dependencies:
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
////////////////////////////////////////////////////////////////////////////////

module testbench_system;

	// Inputs
	reg [34:0] a;
	reg [34:0] b;
	reg [5:0] operation;
	reg operation_nd;
	reg clk;
	reg clk_a;

	// Outputs
	wire operation_rfd;
	wire [34:0] result;
	wire underflow;
	wire overflow;
	wire invalid_op;
	wire rdy;
	
	integer   data_file; //file handler
	integer   data_file_result; //file handler
	integer	 scan_file; //file handler
	reg		 local_reset;	
	reg 		[34:0] sum;
	reg		[2:0] state;
	
	integer dummy;

	`define NULL 0
	
	parameter zero=0, one=1, two=2, three=3, four=4;
	
	// Instantiate the Unit Under Test (UUT)
	system uut (
		.a(a), 
		.b(b), 
		.operation(operation), 
		.operation_nd(operation_nd), 
		.operation_rfd(operation_rfd), 
		.clk(clk),
		.clk_a(clk_a),
		.result(result), 
		.underflow(underflow), 
		.overflow(overflow), 
		.invalid_op(invalid_op), 
		.rdy(rdy)
	);
	
//	test_float_synth temp (
//		quiet(False)
//	);

	initial begin
		// Initialize Inputs
		
		a = 0;
		b = 0;
		operation = 0;
		operation_nd = 0;
		clk = 0;
		local_reset = 1;
		
		data_file = $fopen("fpu_testbench.dat", "r");
		data_file_result = $fopen("fpu_testbench_results.txt", "w");
		if (data_file == `NULL) begin
			$display("data_file handle is NULL");
			$finish;
		end
		// Wait 100 ns for global reset to finish
		#200;
		
		local_reset = 0;
		
		repeat (150000) @ (posedge clk);
		$fclose(data_file);
		$fclose(data_file_result);
		local_reset = 1;
		#100 
		$finish;
//      a = 'h86735C3D;
//		b = 'h51DA7847;
//		operation_nd = 1;
		// Add stimulus here

	end
	
	always @(state) begin
		 case (state)
				zero:	
					operation_nd = 0;
				one:
					scan_file = $fscanf(data_file, "%X %X\n", a, b); 
					//operation_nd = 0;
				two:
					operation_nd = 1;
				three:
					operation_nd = 0;
				four:
					//operation_nd = 0;
					//$display(result);
					$fwrite(data_file_result, "%h\n", result);
		 endcase
//		if(operation_rfd == 1 && local_reset == 0  && rdy == 1) begin
//			scan_file = $fscanf(data_file, "%X %X %X\n", a, b, sum);
//			operation_nd = 1;
//			
//		end;
	end
	
	always @(posedge clk or posedge local_reset) begin
			if (local_reset == 1)	
				state = zero;
			else
				case (state)
						zero:
							if(operation_rfd == 1)
								state = one;
							else
								state = zero;
						one:
							state = two;
						two:
							state = three;
						three:
							if(rdy == 1)
								state = four;
							else
								state = three;
						four:
							state = zero;
				endcase
				
		end
		
	always #5	clk =! clk;
      
endmodule

